/*******************************************************************************
 * HY198_HIGH_SCALER
 * -----------------------------------------------------------------------------
 * function: ߾ȳӣADCЧλؾȡУ
 * author:        MARCK
 * create date:   2014-12-09
 * Library release V0.4
 * Copyright 2014 HYCON Technology
 * http://www.hycontek.com/
 * note: key:PT1.1/PT1.2; ADC INPUT: AI0/AI1   VREF: AI2/AI3
 * modify:chang PT1.1/PT1.2 for the calibrate methods
 *
 ******************************************************************************/
/*----------------------------------------------------------------------------*/
/* Includes                                                                   */
/*----------------------------------------------------------------------------*/
#include "HY16F198.h"
#include "System.h"
#include "DrvGPIO.h"
#include "DrvLCD.h"
#include "DrvCLOCK.h"
#include "DrvPMU.h"
#include "DrvADC.h"
#include "DrvTIMER.h"
#include "specialmacro.h"
#include "drvflash.h"

#include "my define.h"
#include "Display.h"
#include "key.h"
#include "adc_deal.h"
/*----------------------------------------------------------------------------*/
/* STRUCTURES                                                                 */
/*----------------------------------------------------------------------------*/
typedef union _MCUSTATUS
{
  char  _byte;
  struct
  {
    unsigned b_ADCdone:1;
    unsigned b_TMAdone:1;
    unsigned b_TMBdone:1;
    unsigned b_TMC0done:1;
    unsigned b_TMC1done:1;
    unsigned b_RTCdone:1;
    unsigned b_UART_TxDone:1;
    unsigned b_UART_RxDone:1;
  };
} MCUSTATUS;

/*----------------------------------------------------------------------------*/
/* DEFINITIONS                                                                */
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/* Global CONSTANTS                                                           */
/*----------------------------------------------------------------------------*/
MCUSTATUS  MCUSTATUSbits;
extern int adc_value;
/*----------------------------------------------------------------------------*/
/* Function PROTOTYPES                                                        */
/*----------------------------------------------------------------------------*/
void Delay(unsigned int num);
void data_initial(void);
void sys_initial(void);
void scale_sleep(void);
void Displaycal(void);
/*----------------------------------------------------------------------------*/
/* Main Function                                                              */
/*----------------------------------------------------------------------------*/
int main(void)
{
 // unsigned int m=0;
 // unsigned int z=0;
  sys_initial();
  data_initial();
  DisplayInit();
  ClearLCDframe();

 // cal_stander_adc=20000;
 // cal_zero_adc=16;

//read calibration information
  SYS_DisableGIE();    //DISABLE GOLABLE INTERRUPT
  cal_summer=ReadWord(save_addr);
  if((cal_summer!=0)&&(cal_summer!=0xffffffff))  //read information from the flash; not the first time;
  {
	  cal_summer=ReadWord(save_addr);            //read PT1.2
	  if((cal_summer!=0)&&(cal_summer!=0xffffffff))
      {
    	  //get the 'resolution'
    	  resolution=ReadWord(save_addr+0x04);
    	  //get the 'adc_enob'
    	  adc_enob=ReadWord(save_addr+0x8);
    	  //get the 'decimal_piont'
    	  decimal_piont=ReadWord(save_addr+0xc);
    	  //get the 'full_range'
    	  full_range=ReadWord(save_addr+0x10);
    	  //get the "stander_wg'
    	  stander_wg=ReadWord(save_addr+0x14);
    	  //get the 'cal_stander_adc'
    	  cal_stander_adc=ReadWord(save_addr+0x18);//*/
    	  //get the 'cal_zero_adc''
    	  cal_zero_adc=ReadWord(save_addr+0x1c);
      }
	}
  else
  {
	  cal_flag=0x55;			//get into the calibration mode;
	  cal_summer=0;
	  cal_zero_ok=0;			//zero У־
	  cal_stander_ok=0;
		adstbcnt=8;
		adstbok=0;
  }
  SYS_EnableGIE(0X7,0X1FF);
  adc_zero=cal_zero_adc;
  TraceWeight=(float)cal_stander_adc/(stander_wg);
  Tracezero= TraceWeight/2;

  if(DrvGPIO_GetBit(E_PT1,2)==0)            //press pt1.2 begin into calibrate
  	{
	 //	error_num=0;
		adstbcnt=16;
		adstbok=0;
	    cal_zero_ok=0;			//zero У־
	    cal_stander_ok=0;
		if(cal_flag==0)
			cal_flag=0x55;
		else
			cal_flag=0;
		Displaycal();
		while(DrvGPIO_GetBit(E_PT1,2)==0);
		while(cal_flag!=0)
		{
			key_reaction();
			adc_calibrate();
			LCD_Cal_Display();
		}
  	}
  adc_zero=cal_zero_adc;
  TraceWeight=(float)cal_stander_adc/(stander_wg);
  Tracezero= TraceWeight/2;

  DisplayHYcon();				//ʾHYCON
  Delay(50000);
  //==============ȡ===================
	adstbcnt=16;
	adstbok=0;
	  while(adstbok==0)
	  {
		  int j=0;
		  while(ad_bok==0);
		  adc_smooth_filter();
		  while(j<30000)
			{
				j++;
			}
			j=0;
	  }
	  adc_zero=adstable;
	  zerobuf=adc_zero;
	adstbcnt=8;
	adstbok=0;
	adsum=0;

//***********************************************************************************
  time_counter=0;
  SYS_EnableGIE(0X7,0X1FF);    //ENABLE THE GOLABLE INTERRUPT
  while(1)
  {
	  key_reaction();
	  adc_smooth_filter();
	  if(cal_flag==0)			//normal measure weight mode
	  {
		  calculate_wg();
		  if(sys_flag0&0x8)
		  {
			  LCD_DATA_DISPLAY(disweight);
		  }
		  else
		  {
			  time_counter=0;
			  LCD_ADC_Display(adcout);
		  }

	  }

	  else if(cal_flag!=0)  //get into calibration
	  {
		  adc_calibrate();
		  LCD_Cal_Display();
	  }

	  if(time_counter>7500)
	  {//get into the low power mode
		  ClearLCDframe();
		  scale_sleep();
			adstbcnt=16;
			adstbok=0;
			  while(adstbok==0)
			  {
				  int j=0;
				  while(ad_bok==0);
				  adc_smooth_filter();
				  while(j<30000)
					{
						j++;
					}
					j=0;
			  }
			  adc_zero=adstable;
			  zerobuf=adc_zero;
			adstbcnt=8;
			adstbok=0;
			adsum=0;
		  time_counter=0;
	  }
  }

  while(1);
  return 0;
}

/*---------------------------------------------------------------------------*/
/* Hardware Communication Interrupt                                          */
/* UART/SPI/I2C Interrupt Service Routines                                   */
/*---------------------------------------------------------------------------*/
void HW0_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* WDT & RTC & Timer A/B/C Interrupt Service Routines                                         */
/*---------------------------------------------------------------------------*/
void HW1_ISR(void)
{
    if(DrvTIMER_GetIntFlag(E_TMA))
    {
    	DrvTIMER_ClearIntFlag(E_TMA);  //clear timer A interrupt flag
    	key_delay_time++;
    	long_key++;
    	time_counter++;
    }
}

/*----------------------------------------------------------------------------*/
/* HW2 ADC Interrupt Subroutines                                              */
/*----------------------------------------------------------------------------*/
void HW2_ISR(void)
{
	if(DrvADC_ReadIntFlag())                    //check ADC interrupt flag
	{
		DrvADC_ClearIntFlag();       //clear the ADC interrupt flag
		adc_value=DrvADC_GetConversionData()>>8;  //get ADC convert data from 32bit to 24bit
		sys_flag0=sys_flag0^0x02;                   //set the ADC convert success flag
		ad_bok=1;
		adsum++;
	}
}

/*---------------------------------------------------------------------------*/
/* CMP/OPA Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW3_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* PT1 Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW4_ISR(void)
{
	DrvGPIO_ClearIntFlag(E_PT1,0X06);        //clear the interrupt flag;
}

/*---------------------------------------------------------------------------*/
/* PT2 Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW5_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* Software Delay Subroutines                                                */
/*---------------------------------------------------------------------------*/
void Delay(unsigned int num)
{
  for(;num>0;num--)
    asm("NOP");
}
/******************************************************************************
 * name  : sys_initial()
 * func  : initial the system
 * input : no
 * output: no
 * date  : 2014-12-11
 * modify: no
 * *****************************************************************************/
void sys_initial(void)
{
	//setting IC CPU clock
	DrvCLOCK_EnableHighOSC(E_INTERNAL,50);       // enable HAO
	DrvCLOCK_SelectIHOSC(E_2MHZ);                // Select HAO 2MHz
	DrvCLOCK_SelectMCUClock(0,0);
	DrvCLOCK_TrimHAO(0x79);                    //calibration the HAO for 4MHZ;

   //setting the  IO port
	DrvGPIO_ClkGenerator(1,1);
	DrvGPIO_Close(E_PT1,0X06,E_IO_OUTPUT);  //DISABLE PT1.1 PT1.2 OUTPUT MODE
	DrvGPIO_Open(E_PT1,0X06,E_IO_INPUT);   //SET PT1.1 PT1.2 AS INPUT FOR KEY
	DrvGPIO_Open(E_PT1,0X06,E_IO_PullHigh); //enable PT1.1 PT1.2 PULL HIGH;

	//set power manage
	DrvPMU_VDDA_LDO_Ctrl(E_LDO);          //choose VDDA source for LDO mode
	DrvPMU_VDDA_Voltage(E_VDDA2_4);       //set VDDA=2.4V
	DrvPMU_LDO_LowPower(1);               //VDDA LDO WORK FOR LOW POWER
	DrvPMU_BandgapEnable();               //ENABLE BANDGAP VOLTAGE
	DrvPMU_AnalogGround(1);               //SET ANALOG GROUND FOR INERNAL

	Delay(100);

	//setting ADC
	DrvADC_ClkEnable(0,1);          //set ADC clock source HS_CK/6, ADC Clock rising Edge at clock high;
	DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);  //set SIGNAL input: AI0--- AI1
	DrvADC_RefVoltage(AIO2,AIO3);   //VREF INPUT AIO2--AIO3
	DrvADC_FullRefRange(1);         //VREF/2
	DrvADC_Gain(7,3);               //PGA=32,ADGN=4;
	DrvADC_OSR(0);                  //OSR=0/32768,10SPS
	DrvADC_Enable();                //enable ADC
	DrvADC_CombFilter(1);           //setting ADC comb filter auto_drop  the first 3 data
	DrvADC_CombFilter(0);
	DrvADC_CombFilter(1);

	//setting timer A
	DrvTMA_Open(7,E_HS_CK);      //set timer A clock source and over counter
	DrvTMA_ClearTMA();            //clear the timer A counter
	DrvTIMER_ClearIntFlag(E_TMA);  //clear the Timer A interrupt flag
	DrvTIMER_EnableInt(E_TMA);     //enable the Timer A interrupt

	//setting all interrupt
	DrvADC_ClearIntFlag();         //clear the ADC interrupt flag
	DrvADC_EnableInt();           // enable the ADC interrupt

	SYS_EnableGIE(7,0X3F);   //enable all interrupt
}
void data_initial(void)
{
	sys_flag0=0X08;
	cal_flag=0;
	cal_summer=0;
	time_counter=0;
	  Trg=0;
	  Cont=0;
	  key_counter=0;
	  long_key=0;
	  key_delay_time=0;
	  adsum=0;
	  ad_bok=0;
	  cal_zero_ok=0;			//zero У־
	  cal_stander_ok=0;		//stander У־

	  adc_value=0;
	  adstable=0;
	  adcout=0;
	  TraceADCbuf=0;
	  adc_avg=0;
	  adc_zero=0;

	  adc_avg=0;       //ADC average
	  adc_zero=4200;      //zero ADC value
	  adstbcnt=8;       //жADȶĴ
	  adsign=0;			//ж
	  adsignb=0;		//ж
	  ADOK=0;			//ADɱ־   0ADδɣ  1

	 cal_stander_adc=13474;
	 cal_zero_adc=10;
	 full_range=5000;
	 stander_wg=2000;

	 zero_num=0;  //weight is 0 counter
	 def_num=0;
	 adc_enob=18;  //ENOB

	 weight=0;

	 tare_wg=0;
	 resolution=10; //the reslution of weight,С̶ȣ2dʾ仯ڵ2g䡣
	 decimal_piont=0;
}

/*************************************************************
 * name     : void scale_sleep(void)
 * function : system get into low power,wake up by the pt1.1/pt1.2
 * input    : no
 * output   : no
 * note     : no
 ************************************************************/
void scale_sleep(void)
{
	unsigned int IO_buf;
	//setting IO
	DrvGPIO_Open(E_PT1,0Xf9,E_IO_INPUT);   //SET PT1.1 PT1.2 AS INPUT FOR KEY
	DrvGPIO_Open(E_PT1,0Xf9,E_IO_PullHigh); //enable PT1.1 PT1.2 PULL HIGH;

	DrvGPIO_Open(E_PT2,0Xff,E_IO_INPUT);   //SET PT1.1 PT1.2 AS INPUT FOR KEY
	DrvGPIO_Open(E_PT2,0Xff,E_IO_PullHigh); //enable PT1.1 PT1.2 PULL HIGH;

	DrvGPIO_Open(E_PT3,0Xff,E_IO_INPUT);   //SET PT1.1 PT1.2 AS INPUT FOR KEY
	DrvGPIO_Open(E_PT3,0Xff,E_IO_PullHigh); //enable PT1.1 PT1.2 PULL HIGH;
   //setting LCD
	DrvLCD_VLCDMode(0);
	DrvLCD_LCDBuffer(0);
	clk_10=0xFF00;  //LCD CLK=LS_CK
	//setting timer A
	DrvTIMER_DisableInt(E_TMA);     //disable the Timer A interrupt
	DrvTMA_Close();      			//close timer A
	DrvTMA_ClearTMA();            //clear the timer A counter
	DrvTIMER_ClearIntFlag(E_TMA);  //clear the Timer A interrupt flag

	//disable ADC
	DrvADC_ClkDisable();//disable ADC clock;
	DrvADC_Disable();// disable ADC;
	//disable power
	DrvPMU_VDDA_LDO_Ctrl(E_HighZ);
	DrvPMU_BandgapDisable();
	//enable IO interrupt
	DrvGPIO_IntTrigger(E_PT1,0X06,E_N_Edge);  //setting edge trigger
	DrvGPIO_ClearIntFlag(E_PT1,0X06);        //clear the interrupt flag;
	DrvGPIO_Open(E_PT1,0X06,E_IO_IntEnable);  // enable the IO interrupt
	//change the IC clock
	DrvCLOCK_EnableLowOSC(E_INTERNAL,50);
	DrvCLOCK_SelectMCUClock(1,0);
	DrvCLOCK_CloseIHOSC();
	//get into low power mode
    asm("nop");
    asm("nop");
    SYS_LowPower (SYS_SleepMode);//(SYS_WaitMode);
    asm("nop");
    asm("nop");
    IO_buf=DrvGPIO_GetPortBits(E_PT1)&0X06;
    while(IO_buf^0x06)  //wait for free up the key
    {
    	IO_buf=DrvGPIO_GetPortBits(E_PT1)&0X06;
    }
	//setting IC CPU clock
	DrvCLOCK_EnableHighOSC(E_INTERNAL,1);       // enable HAO
	DrvCLOCK_SelectMCUClock(0,0);
	//disable IO interrupt
	DrvGPIO_Close(E_PT1,0X06,E_IO_IntEnable);  // disable the IO interrupt
	DrvGPIO_ClearIntFlag(E_PT1,0X06);        //clear the interrupt flag;
	DrvGPIO_IntTrigger(E_PT1,0X06,00);  //setting edge trigger

    //setting power
	DrvPMU_VDDA_LDO_Ctrl(E_LDO);          //choose VDDA source for LDO mode
	DrvPMU_VDDA_Voltage(E_VDDA2_4);       //set VDDA=2.4V
	DrvPMU_BandgapEnable();               //ENABLE BANDGAP VOLTAGE

	//enable the ADC
	DrvADC_ClkEnable(0,1);          //set ADC clock source HS_CK/12, ADC Clock rising Edge at clock high;
	DrvADC_Enable();                //enable ADC

	//enable the timer A
	DrvTMA_Open(7,E_HS_CK);      //set timer A clock source and over counter
	DrvTMA_ClearTMA();            //clear the timer A counter
	DrvTIMER_ClearIntFlag(E_TMA);  //clear the Timer A interrupt flag
	DrvTIMER_EnableInt(E_TMA);     //enable the Timer A interrupt

	//setting LCD
    clk_10=0xFF16;  //LCD CLK=LS_CK
	DrvLCD_VLCDMode(E_VLCD30);
	DrvLCD_LCDBuffer(ENABLE);

	SYS_EnableGIE(0X7,0X1FF);
}
/*---------------------------------------------------------------------------*/
/* End Of File                                                               */
/*---------------------------------------------------------------------------*/
