/*
 * key_deal.c
 *
 *  Created on: 2014-12-9
 *      Author: Administrator
 */
#define IN_KEY
#define ADC_DEAL
#include "drvGPIO.h"
#include "my define.h"
#include "key.h"
#include "adc_deal.h"

/**************************************************************************
 * name: key_scan()
 * func: read the value of pt1.1 pt1.2
 * input: no
 * output: key number
 * note:  PT1.1/PT1.2 as input for key
 *        PT1.1: normal--tear (short press)
 *               setting--change different setting
 *******************************************************************/
unsigned char key_scan(void)
{
	unsigned char ReadData =(DrvGPIO_GetPortBits(E_PT1)&0x06)^0x06; // 1
	Trg=ReadData&(ReadData^Cont); // 2
	Cont=ReadData;  // 3
	switch(key_counter)
	{
	case 0:   //trig first time
	{
		if(Trg!=0)   // key trig for first time
		{
			Trg=0;
			Cont=0;
			key_delay_time=0;
			key_counter++;
		}
		else
		{
			Trg=0;
			Cont=0;
		}
		break;
	}
	case 1:
	{
		if(key_delay_time>=key_time)
		{
			if(Trg!=0)  //the true press key
			{
				key_counter++;
				long_key=0;
			}
			else       //false press key
			{
				Trg=0;
				Cont=0;
				key_delay_time=0;
				key_counter=0;
				long_key=0;
			}
		}
		else
		{
			Trg=0;
			Cont=0;
		}
		break;
	}
	case 2:
	{
		if(Cont!=0)
		{
			key_value=Cont;
			//long_key++;
			if(long_key > key_long_time)      //long time press
			{
				//sys_flag0=sys_flag0|0x01;  //
				key_counter++;
				key_delay_time=0;
				return 0x1;
			}
		}
		else
		{
			//sys_flag0=sys_flag0|0x01;  //
			key_counter++;
			key_delay_time=0;
			return 0x1;
		}
		break;
	}
	case 3:
	{
		if(Cont==0)
		{
			if(key_delay_time>2)
			{
				Trg=0;
				Cont=0;
				key_delay_time=0;
				key_counter=0;
			}

		}
		else
			key_delay_time=0;
		break;
	}
	default:
		break;
	}
    return 0;
}

void key_reaction(void)
{
	if(key_scan())
	{
		if(key_value&0x02)  						//pt1.1
		{
			key_value=0;
			if(long_key>key_long_time)      		//PT1.1 long time press
			{
				long_key=0;
				if(cal_flag==0x55)					//display adc
				{
					cal_flag=0x01;
				}
				else if(cal_flag!=0&&cal_flag<0x20)
				{
					cal_flag=0x7f&(cal_flag<<1);    //change different object;
					if(cal_flag==0)
						cal_flag=0x1;
				}
				else if(cal_flag&0x20)  			//cal_zero
				{
					cal_flag=cal_flag^0x80;   		//start zero weight calibration function flag
				}
				else if(cal_flag==0x40)  			//cal_stander weight
				{
					cal_flag=cal_flag^0x80; 		//start stander weight calibration function flag
				}
			}

			else 									//PT1.1 short time press
			{
				if(cal_flag==0)
					sys_flag0=sys_flag0^0x04;  		//tare/zero flag =1;
				else if(cal_flag==0x55)
					asm("nop");
				else if(cal_flag&0x1)   				 //setting full scale
				{
					full_range=full_range-500;  	//step is 500g
					if(full_range<=0)
					full_range=10000;
				}
				else if(cal_flag&0x2)              	//setting stander calibration weight;
				{
				    stander_wg=stander_wg-500; 		//step is 500g
				    if(stander_wg<=0)
				    stander_wg=10000;
				}
				else if(cal_flag&0x4)  			//setting reslution;С̶ֵ
				{
					resolution=resolution-5;  //resolution=(float)((int)(resolution*10-1)/10);
					if(resolution<=0)
					resolution=20;
				}
				else if(cal_flag&0x8)		 //setting point;Сλã
				{
					decimal_piont--;
					if(decimal_piont<0)
						decimal_piont=3;
				}
				else if(cal_flag&0x10)   	//setting the ENOB
				{
					adc_enob=adc_enob-1;
					if(adc_enob<=0)
						adc_enob=24;
				}
			}
		}

	/*		if(cal_flag==0)
				sys_flag0=sys_flag0^0x04;  //tare/zero flag =1;else   							   //then cal_flag=1 the first time;
			{
				cal_flag=0x7f&(cal_flag<<1);    //change different object;
				if(cal_flag==0)
					cal_flag=0x1;
			}

		}    */

		else if(key_value&0x04)  		//pt1.2
		{
			key_value=0;
			if(long_key>key_long_time)  //long time press
			{
				 ;
			/*	long_key=0;
				if(cal_flag==0)
					cal_flag=1;
				else
					cal_flag=0;
					*/
			}
			else                         //pt1.2 short press
			{
				if(cal_flag!=0)
				{
					if(cal_flag==0x55)			//Уģʽ,Ч
						asm("nop");
					else if(cal_flag&0x1)    //setting full scale
						{
							full_range=full_range+500;  //step is 500g
							if(full_range>=10000)
								full_range=0;
						}
                    else if(cal_flag&0x2)              //setting stander calibration weight;
                        {
                            stander_wg=stander_wg+500; //step is 500g
                            if(stander_wg>=10000)
                            	stander_wg=0;
                        }
					else if(cal_flag&0x4)  //setting reslution;С̶ֵ
						{
						resolution=resolution+5; //resolution=(float)((int)(resolution*10+1)/10);
							if(resolution>20)
								resolution=5;
						}
					else if(cal_flag&0x8) //setting point;Сλã
						{
							decimal_piont++;
							if(decimal_piont>3)
								decimal_piont=0;
						}
					else if(cal_flag&0x10)   //setting the ENOB
					{
						adc_enob=adc_enob+1;
						if(adc_enob>24)
							adc_enob=1;

					}
		/*			else if(cal_flag&0x20)  //cal_zero
						{
                           cal_flag=cal_flag^0x80;   //start zero weight calibration function flag
						}
					else if(cal_flag&0x40)  //cal_stander weight
						{
						   cal_flag=cal_flag^0x80; //start stander weight calibration function flag
						}   */
				}
				else    //short press  'ADC CODE OR weight',0:ADC CODE; 1: weight;
				{
					sys_flag0=sys_flag0^0x8;
				}
			}
		}

	}

}
